
	; BCC's name is misleading and lots of people use BGE instead (am I right? =D )
	; Let's make things clear via SANDBOX!

	move.w	#$10,d0		; move $10 to d0      

; --------------------------------------------------------------
	
Test1:
	out	'cmpi.w  #0,d0'
	break
	cmpi.w	#0,d0		; compare d0 with 0
	bcc.s	BCCWorks1
	out	"BCC didn't work!"
	bra.s	Test2

BCCWorks1:
	out	'BCC worked!'

; --------------------------------------------------------------

Test2:
	pause
	out	'cmpi.w  #$20,d0'
	break
	cmpi.w	#$20,d0		; compare d0 with $20
	bcc.s	BCCWorks2
	out	"BCC didn't work!"
	bra.s	Test3

BCCWorks2:
	out	'BCC worked!'

; --------------------------------------------------------------

Test3:
	pause
	out	'cmpi.w  #$10,d0'
	break
	cmpi.w	#$10,d0		; compare d0 with $10
	bcc.s	BCCWorks3
	out	"BCC didn't work!"
	bra.s	Test4

BCCWorks3:
	out	'BCC worked!'

; --------------------------------------------------------------

; Can you see it? =)
; So, when you command: cmp  d1,d0
; BCC works, when d0 is Greater or Equals to d1.

; But wait... What's the difference between BCC and BGE?
; Les's see:

; --------------------------------------------------------------

Test4:
	pause
	move.w	#$FF00,d0	; let's work with such a big number
	cmpi.w	#0,d0		; compare big number with 0
	bcc.s	BCCWorks4	; MUST WORK!
	out	"BCC didn't work!"
	bra.s	Test5

BCCWorks4:
	out	'BCC worked!'

; --------------------------------------------------------------
; Now test it with BGE

Test5:
	pause
	move.w	#$FF00,d0	; let's work with such a big number
	cmpi.w	#0,d0		; compare big number with 0
	bge.s	BGEWorks	; MUST WORK!
	out	"BGE didn't work!"
	bra.s	Exit

BGEWorks:
	out	'BGE worked!'

; --------------------------------------------------------------
; Why so?
; Hint:

Exit:
	pause
	outw	d0
	break
	outw	d0,signed
	rts

; --------------------------------------------------------------
; Using BCC instead of BGE is always better, in case you are not
; comparing signed numbers.

; Also, here is a very useful table for you, it always helps me:

; Relationship      Unsigned                         Signed
; -------------     ---------                        -------
; D0 <  D1          CS - Carry Bit Set               LT - Less Than
; D0 <= D1          LS - Lower or Same               LE - Less than or Equal
; D0  = D1          EQ - Equal (Z-bit Set)           EQ - Equal (Z-bit Set)
; D0 != D1          NE - Not Equal (Z-bit Clear)     NE - Not Equal (Z-bit Clear)
; D0 >  D1          HI - HIgher than                 GT - Greater Than
; D0 >= D1          CC - Carry Bit Clear             GE - Greater than or Equal
;
;                   PL - PLus (N-bit Clear)          MI - Minus (N-bit Set)
;                   VC - V-bit Clear (No Overflow)   VS - V-bit Set (Overflow)

; --------------------------------------------------------------