
; This is advanced example, showing how to made HEX viewer in SANDBOX. 
; The viewer can show any data, like machine code, which may be useful

; Declare some varuiables, yeah!

ItemsOnRow = 8


; Here starts the code

	lea	(HEXView_Start),a0	; load data we're going to show
	moveq	#ItemsOnRow+1,d0	; set cols counter

HEXView_DisplayLoop:
	subq.b	#1,d0			; sub 1 from the counter
	bne.s	@show			; if it's not zero, branch
	move.b	#ItemsOnRow,d0		; reset counter
	break				; go to the next line

@show:	outb	(a0)+			; out put a byte
	out	' '			; make a space between them

	cmpa.l  #HEXView_End,a0		; have we reached the end?
	bne.s	HEXView_DisplayLoop	; if not, go on displaying

	rts


; Data Section, you can place any data here, the code won't run.

HEXView_Start:
	move.w	#0,d0
	move.w	#$F0C0,d0
	clr.w	d0
	dc.b	1,2,3,4,5
	dc.b	'SEGA'
HEXView_End

	even	; make sure, it's word aligned
