; ===========================================================================
; M68K Sandbox v.1.0
; (C) 2010, Vladikcomper
; ---------------------------------------------------------------------------
; Data inclusions
; ===========================================================================

FontGfx		incbin	'data\font.bin'	; font graphics (1bpp format)
FontPall	dc.w	$0000,$0EEE	; normal text
		dc.w	$0000,$0AAA	; console system msg
		dc.w	$0222,$00EE	; selected tab/item
		dc.w	$0800,$0EEE	; upper and bottom bars
DecArray        dc.l	1000000000
		dc.l	100000000
		dc.l	10000000
		dc.l	1000000
		dc.l	100000
		dc.l	10000
		dc.l	1000
		dc.l	100
		dc.l	10
		dc.l	1
TitleStr	dc.b	'SANDBOX by Vladikcomper    version 1.0'
TabStr		dc.b	'Console',$80,'Registers',$80,'RAM',$80,'Code View',$80
StatusArray	dc.b	'Press [START] to launch a program     ' ;0
		dc.b	'Busy...                               ' ;1
		dc.b	'[START] Quit  [L/R] Mode              ' ;2
		dc.b	'[START] Quit  [L/R] Mode  [C] Continue' ;3
		dc.b	'[START] Quit  [L/R] Mode  [C/B] Scroll' ;4
ConsoleMsg	dc.b	'Program start       '
		dc.b	'Program paused      '
		dc.b	'Program terminate   '
ErrorArray	dc.b	'Error Exception     '
		dc.b	'Bus Error           '
		dc.b	'Address Error       '
		dc.b	'Illegal Instruction '
		dc.b	'Zero Divide         '
		dc.b	'CHK Instruction     '
		dc.b	'TRAPV Instruction   '
		dc.b	'Privilege Violation '
		dc.b	'Trace               '
		dc.b	'Line 1010 Emulator  '
		dc.b	'Line 1111 Emulator  '